//-----------------------------------------------------------------------------
// Torque Game Engine 
// Copyright (C) GarageGames.com, Inc.
//-----------------------------------------------------------------------------

// Load dts shapes and merge animations
datablock TSShapeConstructor(headcrabDts)
{
	baseShape  = "./headcrab.dts";
	sequence0  = "./hc_root.dsq root";

	sequence1  = "./hc_run.dsq run";
	sequence2  = "./hc_run.dsq walk";
	sequence3  = "./hc_run.dsq back";
	sequence4  = "./hc_root.dsq side";

	sequence5  = "./hc_root.dsq crouch";
	sequence6  = "./hc_run.dsq crouchRun";
	sequence7  = "./hc_run.dsq crouchBack";
	sequence8  = "./hc_root.dsq crouchSide";

	sequence9  = "./hc_root.dsq look";
	sequence10 = "./hc_root.dsq headside";
	sequence11 = "./hc_root.dsq headUp";

	sequence12 = "./hc_jump.dsq jump";
	sequence13 = "./hc_jump.dsq standjump";
	sequence14 = "./hc_root.dsq fall";
	sequence15 = "./hc_root.dsq land";

	sequence16 = "./hc_Attack.dsq armAttack";
	sequence17 = "./hc_root.dsq armReadyLeft";
	sequence18 = "./hc_root.dsq armReadyRight";
	sequence19 = "./hc_root.dsq armReadyBoth";
	sequence20 = "./hc_root.dsq spearready";  
	sequence21 = "./hc_root.dsq spearThrow";

	sequence22 = "./hc_root.dsq talk";  

	sequence23 = "./hc_root.dsq death1"; 
	
	sequence24 = "./hc_root.dsq shiftUp";
	sequence25 = "./hc_root.dsq shiftDown";
	sequence26 = "./hc_root.dsq shiftAway";
	sequence27 = "./hc_root.dsq shiftTo";
	sequence28 = "./hc_root.dsq shiftLeft";
	sequence29 = "./hc_root.dsq shiftRight";
	sequence30 = "./hc_root.dsq rotCW";
	sequence31 = "./hc_root.dsq rotCCW";

	sequence32 = "./hc_root.dsq undo";
	sequence33 = "./hc_root.dsq plant";

	sequence34 = "./hc_root.dsq sit";

	sequence35 = "./hc_root.dsq wrench";

   sequence36 = "./hc_root.dsq activate";
   sequence37 = "./hc_root.dsq activate2";

   sequence38 = "./hc_root.dsq leftrecoil";
};    


datablock AudioProfile(headcrabJumpSound)
{
   fileName = "./jumphorse.wav";
   description = AudioClose3d;
   preload = true;
};


datablock DebrisData( headcrabDebris )
{
   explodeOnMaxBounce = false;

   elasticity = 0.15;
   friction = 0.5;

   lifetime = 4.0;
   lifetimeVariance = 0.0;

   minSpinSpeed = 40;
   maxSpinSpeed = 600;

   numBounces = 5;
   bounceVariance = 0;

   staticOnMaxBounce = true;
   gravModifier = 1.0;

   useRadiusMass = true;
   baseRadius = 1;

   velocity = 20.0;
   velocityVariance = 12.0;
};             

datablock PlayerData(headcrabArmor)
{
   renderFirstPerson = false;
   emap = false;
   
   className = Armor;
   shapeFile = "./headcrab.dts";
   cameraMaxDist = 4;
   cameraTilt = 0.261;//0.174 * 2.5; //~25 degrees
   cameraVerticalOffset = 0.6;
   computeCRC = false;
  
   canObserve = true;
   cmdCategory = "Clients";

   cameraDefaultFov = 90.0;
   cameraMinFov = 5.0;
   cameraMaxFov = 120.0;
   
   //debrisShapeName = "~/data/shapes/player/debris_player.dts";
   //debris = headcrabDebris;

   aiAvoidThis = true;

   minLookAngle = -1.5708;
   maxLookAngle = 1.5708;
   maxFreelookAngle = 3.0;

   mass = 90;
   drag = 0.1;
   maxdrag = 0.52;
   density = 0.7;
   maxDamage = 250;
   maxEnergy =  10;
   repairRate = 0.33;
   energyPerDamagePoint = 75.0;

   rechargeRate = 0.4;

   runForce = 28 * 90;
   runEnergyDrain = 0;
   minRunEnergy = 0;
   maxForwardSpeed = 6;
   maxBackwardSpeed = 6;//exec("add-ons/vehicle_headcrab/server.cs");
   maxSideSpeed = 1;

   maxForwardCrouchSpeed = 12;
   maxBackwardCrouchSpeed = 6;
   maxSideCrouchSpeed = 1;

   maxForwardProneSpeed = 0;
   maxBackwardProneSpeed = 0;
   maxSideProneSpeed = 0;

   maxForwardWalkSpeed = 0;
   maxBackwardWalkSpeed = 0;
   maxSideWalkSpeed = 0;

   maxUnderwaterForwardSpeed = 8.4;
   maxUnderwaterBackwardSpeed = 7.8;
   maxUnderwaterSideSpeed = 7.8;

   jumpForce = 13 * 90; //8.3 * 90;
   jumpEnergyDrain = 0;
   minJumpEnergy = 0;
   jumpDelay = 0;

   minJetEnergy = 0;
	jetEnergyDrain = 0;
	canJet = 0;

   recoverDelay = 0;
   recoverRunForceScale = 1.2;

   minImpactSpeed = 250;
   speedDamageScale = 3.8;

   boundingBox			= vectorScale("1.0 1.0 1.0", 4); //"2.5 2.5 2.4";
   crouchBoundingBox	= vectorScale("1.0 1.0 1.0", 4); //"2.5 2.5 2.4";
   proneBoundingBox		= vectorScale("1.0 1.0 1.0", 4); //"2.5 2.5 2.4";

   pickupRadius = 0.75;
   
   // Damage location details
   boxNormalHeadPercentage       = 0.83;
   boxNormalTorsoPercentage      = 0.49;
   boxHeadLeftPercentage         = 0;
   boxHeadRightPercentage        = 1;
   boxHeadBackPercentage         = 0;
   boxHeadFrontPercentage        = 1;

   // Foot Prints
   //decalData   = headcrabFootprint;
   //decalOffset = 0.25;
	
   jetEmitter = "";
   jetGroundEmitter = "";
   jetGroundDistance = 4;
  
   //footPuffEmitter = LightPuffEmitter;
   footPuffNumParts = 10;
   footPuffRadius = 0.25;

   //dustEmitter = LiftoffDustEmitter;

   splash = PlayerSplash;
   splashVelocity = 4.0;
   splashAngle = 67.0;
   splashFreqMod = 300.0;
   splashVelEpsilon = 0.60;
   bubbleEmitTime = 0.1;
   splashEmitter[0] = PlayerFoamDropletsEmitter;
   splashEmitter[1] = PlayerFoamEmitter;
   splashEmitter[2] = PlayerBubbleEmitter;
   mediumSplashSoundVelocity = 10.0;   
   hardSplashSoundVelocity = 20.0;   
   exitSplashSoundVelocity = 5.0;

   // Controls over slope of runnable/jumpable surfaces
   runSurfaceAngle  = 85;
   jumpSurfaceAngle = 86;

   minJumpSpeed = 20;
   maxJumpSpeed = 30;

   horizMaxSpeed = 68;
   horizResistSpeed = 33;
   horizResistFactor = 0.35;

   upMaxSpeed = 80;
   upResistSpeed = 25;
   upResistFactor = 0.3;
   
   footstepSplashHeight = 0.35;

   //NOTE:  some sounds commented out until wav's are available

   JumpSound			= headcrabJumpSound;

   // Footstep Sounds
//   FootSoftSound        = headcrabFootFallSound;
//   FootHardSound        = headcrabFootFallSound;
//   FootMetalSound       = headcrabFootFallSound;
//   FootSnowSound        = headcrabFootFallSound;
//   FootShallowSound     = headcrabFootFallSound;
//   FootWadingSound      = headcrabFootFallSound;
//   FootUnderwaterSound  = headcrabFootFallSound;
   //FootBubblesSound     = FootLightBubblesSound;
   //movingBubblesSound   = ArmorMoveBubblesSound;
   //waterBreathSound     = WaterBreathMaleSound;

   //impactSoftSound      = ImpactLightSoftSound;
   //impactHardSound      = ImpactLightHardSound;
   //impactMetalSound     = ImpactLightMetalSound;
   //impactSnowSound      = ImpactLightSnowSound;
   
   impactWaterEasy      = Splash1Sound;
   impactWaterMedium    = Splash1Sound;
   impactWaterHard      = Splash1Sound;
   
   groundImpactMinSpeed    = 10.0;
   groundImpactShakeFreq   = "4.0 4.0 4.0";
   groundImpactShakeAmp    = "1.0 1.0 1.0";
   groundImpactShakeDuration = 0.8;
   groundImpactShakeFalloff = 10.0;
   
   //exitingWater         = ExitingWaterLightSound;
   
   observeParameters = "0.5 4.5 4.5";

   // Inventory Items
	maxItems   = 10;	//total number of bricks you can carry
	maxWeapons = 5;		//this will be controlled by mini-game code
	maxTools = 5;
	
	uiName = "headcrab";
	rideable = true;
		lookUpLimit = 0.6;
		lookDownLimit = 0.2;

	canRide = false;
	showEnergyBar = false;
	paintable = true;

	brickImage = headcrabBrickImage;	//the imageData to use for brick deployment

   numMountPoints = 1;
   mountThread[0] = "root";
   mountNode[0] = 2;
};



function headcrabArmor::onAdd(%this,%obj)
{
   // Vehicle timeout
   %obj.mountVehicle = true;

   // Default dynamic armor stats
   %obj.setRechargeRate(%this.rechargeRate);
   %obj.setRepairRate(0);

}



//called when the driver of a player-vehicle is unmounted
function headcrabArmor::onDriverLeave(%obj, %player)
{
	//do nothing
}
package headcrab
{
   function headcrabArmor::onCollision(%this, %obj, %col, %a, %b)
   {
      parent::onCollision(%this, %obj, %col, %a, %b);
      schedule(10, 0, checkheadcrabMount, %obj, %col);
   }
   function checkheadcrabMount(%obj, %player)
   {
      if(%player.getObjectMount() $= %obj)
      {
         %player.hideNode("HeadSkin");
         for (%i = 0; $accent[%i] !$= ""; %i++) %player.hideNode($accent[%i]);
         for (%i = 0; $chest[%i] !$= ""; %i++) %player.hideNode($chest[%i]);
         for (%i = 0; $hat[%i] !$= ""; %i++) %player.hideNode($hat[%i]);
         for (%i = 0; $hip[%i] !$= ""; %i++) %player.hideNode($hip[%i]);
         for (%i = 0; $LArm[%i] !$= ""; %i++) %player.hideNode($LArm[%i]);
         for (%i = 0; $RArm[%i] !$= ""; %i++) %player.hideNode($RArm[%i]);
         for (%i = 0; $LHand[%i] !$= ""; %i++) %player.hideNode($LHand[%i]);
         for (%i = 0; $LLeg[%i] !$= ""; %i++) %player.hideNode($LLeg[%i]);
         for (%i = 0; $pack[%i] !$= ""; %i++) %player.hideNode($pack[%i]);
         for (%i = 0; $RHand[%i] !$= ""; %i++) %player.hideNode($RHand[%i]);
         for (%i = 0; $RLeg[%i] !$= ""; %i++) %player.hideNode($RLeg[%i]);
         for (%i = 0; $secondPack[%i] !$= ""; %i++) %player.hideNode($secondPack[%i]);
         %player.setScale("1 1 1");
      }
   }
   function Armor::onTrigger(%this, %obj, %triggerNum, %val)
   {
      if(%triggerNum $= 4)
      {
         if(%obj.getObjectMount().getDatablock() $= headcrabArmor.getID())
         {
            %player = %obj;
            %player.unHideNode("HeadSkin");
            %player.client.applyBodyParts();
            %player.client.applyBodyColors();
            %player.setScale("1 1 1");
         }
      }
      parent::onTrigger(%this, %obj, %triggerNum, %val);
   }
};
activatePackage(headcrab);